// SaftyMatch
//
// =======================
// global vars  - reqd by plot + draw
int gx;	// 0,0 bot, left of screen
int gy;	// 159,159 top, right

// Set co-ordinates on screen
plot (int x, int y){
    gx=x;
    gy=y;
}

// Draw line to x,y from plot posn.
draw(int t, int x, int y){
    x = gx + x;    y = gy + y;
    line(t, gx, 159-gy, x, 159-y);
    gx=x; gy=y;
}

// =======================
// Find x,y locn on screen for match.
int ly(int m){
   return (124 - (m/5)*20) ;
}
int lx(int m){
    int a;
    a=m-((m/5)*5) ;
    return(20 + a*30) ;
}

// Cross off the match
crossMatch(int l, int m, int d) {
    int x, y, i;
    l--;
    for(i=0; i<m; i++) {
	x=lx(l)+(d*5);
	y=ly(l)+5; l--;
	plot (x, y);
	draw(1, d*-10, 10);
	draw(1, 0, 1);
	draw(1, d*10, -10);
    }
}

// Obviously draw a match on screen
drawMatch(int m) {
    int x, y;
    x=lx(m);    y=ly(m);
    plot(x,y+12) ;
    draw (1,0,-12) ;	draw (1,2,0) ;
    draw (1,0,12) ;	draw (2,1,0) ;
    draw (2,0,3) ;	draw(2,-4,0) ;
    draw(2,0,-3) ;	draw(2,4,0) ;
}

// =======================
// Initialise the screen for the game
int setScreen(int max, int matches){
    int l, x, y, s, r;

    graph_on(); clearg();
    textattr(0, 1, 0);
    title("Safty Match");

    // Draw the number boxes
    for(l=0; l<max; l++) {
	x=(l*20) +10 + ((l*20)/2);
	plot(x, 5);	s=20;
	draw(1,s,0);	draw(1,0,s);
	draw(1,-s,0);	draw(1,0, -s);
	text(x+8, 159-20, (l+1));
    }
    text(4, 159-36,
	"Number of matches to take:");

    // Draw the matches
    for (l=0; l<matches; l++)
        drawMatch(l);
}

// =======================
// Get user input
int getNumber(int l, int m) {
    int x, y;
    while(1){
	waitp();
	x = penx();
	y = 159 - peny() - 5;
	if (y>0 && y<20) {
	    x=(x-10)/30 + 1;
	    if (x>0 && x<=m && x<=l)
		break;
	}
    }
    beep(1);
    return(x);
}
// =======================
// Rommy's move
int rommy(int l, int m) {
    int g, r;
    l--; m++;
    r=random(m-1)+1;
    g=l/m; g=l-(g*m); // modulus
    if (l<1) return (0);
    if (g==0) return (r);
    return (g);
}

// =======================
// MAIN Function
main() {
    int m, l, t;
    int won, lost;
    string str;

    // Show the credits
    clear();
    puts("Safty Match:	by Graham Oakes\nIs a strategy game where you try and get the computer (Rommy) to cross off the last match. The number of matches + takable matches vary each game. Send me an e-mail with your comments to: \n	grahamo@us.ibm.com\n\nHope you have fun!!\n	Tap sceen to start.");
    beep(4); waitp();
    won=0; lost=0;

    // Lets go
    while(1) {
	m=random(3)+3;
	l=random(11)+15;
	setScreen(m, l);

	while(1) {
	    // human go
	    t = getNumber(l, m);
	    crossMatch(l, t, 1);
	    l=l-t;
	    if (l==1) {
	         str="YOU ARE THE WINNER";
	         won++; beep(4);
	         break;
	    }
	    if (l==0) {
		str="You took last match - Rommy wins";
		lost++; beep(3);
		break;
	    }

	    // rommy's go
	    t=rommy(l, m);
	    crossMatch(l, t, -1);
	    l=l-t;
	    if (t==0)  {
	         str="YOU ARE THE WINNER";
	         won++; beep(4);
	         break;
	    }
	    if (l==1)  {
		str="You have to take last match - Rommy wins";
		lost++; beep(3);
		break;
	    }
	}

	// Game over
	str=str + ".\nYou " + won +
	    "   Rommy " + lost + ".\n";
	str=alert(str+ "Another GO?");
    }
}